#ifndef CUSTOMMAPLIST_H
#define CUSTOMMAPLIST_H

#include<qdir.h>
#include<qstringlist.h>
#include<qtextstream.h>
#include<qfile.h>
#include<map>
#include"maplist.h"

#include<stdio.h>

class CustomMapList : public MapList {
public:
	CustomMapList();
	~CustomMapList();
	QString searchMapFileName(long ns, long ew, Radian *radMapEW,
			Radian *radMapNS, Radian *radMapWidth, Radian *radMapHeight);
	QString pointMapFileName(int diffLat, int diffLong, Radian *radMapEW,
			Radian *radMapNS, Radian *radMapWidth, Radian *radMapHeight);
	void createMapList();
	void changeMap(const QString &path);
	QString getClassName() {
		return "CustomMapList";
	}

private:
	void updateItudeList(const QString &path, map<long, int> *longitude,
			map<long, int> *latitude, unsigned int * maxFileLen);
	void updateMapList(const QString &path, QFile *mapListFile);
	bool getMapInfo(QString mapFileName, Radian *radMapEW, Radian *radMapNS,
			Radian *radMapWidth, Radian *radMapHeight);

	QString _basePath;
	QFile _mapListFile;
	map<long, int> _latitude;
	map<long, int> _longitude;
	int _latid, _longid;
	unsigned int _maxFileLen;
	unsigned long _baseLength;

	//const long _index_size = sizeof(Q_UINT32) + sizeof(long) * 2;
	//Q_UINT32 _magicNumber = 0x15614878;
};

#endif //CUSTOMMAPLIST_H
